DLS::Articulator Class Reference

Abstract base class for classes that provide articulation information (thus for Instrument and Region class). More...

`#include <DLS.h>`

Inheritance diagram for DLS::Articulator:

## Public Member Functions

| Articulator (RIFF::List *ParentList)
Articulation * | GetArticulation (size_t pos)
| Returns Articulation at supplied pos position within the articulation list.
Articulation * | GetFirstArticulation ()
| Returns the first Articulation in the list of articulations.
Articulation * | GetNextArticulation ()
| Returns the next Articulation from the list of articulations.
virtual void | UpdateChunks (progress_t *pProgress)
| Apply all articulations to the respective RIFF chunks.
virtual void | DeleteChunks ()
| Remove all RIFF chunks associated with this Articulator object.
virtual void | CopyAssign (const Articulator *orig)
| Not yet implemented in this version, since the .gig format does not need to copy DLS articulators and so far nobody used pure DLS instrument AFAIK.

## Protected Types

typedef std::vector< Articulation * > | ArticulationList

## Protected Member Functions

void | LoadArticulations ()

## Protected Attributes

RIFF::List * | pParentList
ArticulationList * | pArticulations
ArticulationList::iterator | ArticulationsIterator

## Detailed Description

Abstract base class for classes that provide articulation information (thus for Instrument and Region class).

Definition at line 343 of file DLS.h.

## Member Typedef Documentation

## ArticulationList

typedef std::vector<Articulation*> DLS::Articulator::ArticulationList

protected

Definition at line 353 of file DLS.h.

## Constructor & Destructor Documentation

## Articulator()

DLS::Articulator::Articulator | ( | RIFF::List * | ParentList | ) |

Definition at line 187 of file DLS.cpp.

## ~Articulator()

DLS::Articulator::~Articulator | ( |  | ) |

protected virtual

Definition at line 259 of file DLS.cpp.

## Member Function Documentation

## CopyAssign()

void DLS::Articulator::CopyAssign | ( | const Articulator * | orig | ) |

virtual

Not yet implemented in this version, since the .gig format does not need to copy DLS articulators and so far nobody used pure DLS instrument AFAIK.

Definition at line 306 of file DLS.cpp.

Referenced by DLS::Region::CopyAssign().

## DeleteChunks()

void DLS::Articulator::DeleteChunks | ( |  | ) |

virtual

Remove all RIFF chunks associated with this Articulator object.

See Storage::DeleteChunks() for details.

Implements DLS::Storage.

Reimplemented in DLS::Instrument, and DLS::Region.

Definition at line 291 of file DLS.cpp.

Referenced by DLS::Instrument::DeleteChunks(), and DLS::Region::DeleteChunks().

## GetArticulation()

Articulation * DLS::Articulator::GetArticulation | ( | size_t | pos | ) |

Returns Articulation at supplied pos position within the articulation list.

If supplied pos is out of bounds then `NULL` is returned.

Parameters

  pos | - position of sought Articulation in articulation list

Returns
  pointer address to requested articulation or `NULL` if pos is out of bounds

Definition at line 200 of file DLS.cpp.

## GetFirstArticulation()

Articulation * DLS::Articulator::GetFirstArticulation | ( |  | ) |

Returns the first Articulation in the list of articulations.

You have to call this method once before you can use GetNextArticulation().

Returns
  pointer address to first Articulation or NULL if there is none

See also
  GetNextArticulation()

Deprecated
  This method is not reentrant-safe, use GetArticulation() instead.

Definition at line 216 of file DLS.cpp.

## GetNextArticulation()

Articulation * DLS::Articulator::GetNextArticulation | ( |  | ) |

Returns the next Articulation from the list of articulations.

You have to call GetFirstArticulation() once before you can use this method. By calling this method multiple times it iterates through the available articulations.

Returns
  pointer address to the next Articulation or NULL if end reached

See also
  GetFirstArticulation()

Deprecated
  This method is not reentrant-safe, use GetArticulation() instead.

Definition at line 234 of file DLS.cpp.

## LoadArticulations()

void DLS::Articulator::LoadArticulations | ( |  | ) |

protected

Definition at line 240 of file DLS.cpp.

## UpdateChunks()

void DLS::Articulator::UpdateChunks | ( | progress_t * | pProgress | ) |

virtual

Apply all articulations to the respective RIFF chunks.

You have to call File::Save() to make changes persistent.

Parameters

  pProgress | - callback function for progress notification

Implements DLS::Storage.

Reimplemented in DLS::Instrument, DLS::Region, gig::Instrument, and gig::Region.

Definition at line 277 of file DLS.cpp.

Referenced by DLS::Instrument::UpdateChunks(), and DLS::Region::UpdateChunks().

## Member Data Documentation

## ArticulationsIterator

ArticulationList::iterator DLS::Articulator::ArticulationsIterator

protected

Definition at line 356 of file DLS.h.

## pArticulations

ArticulationList* DLS::Articulator::pArticulations

protected

Definition at line 355 of file DLS.h.

## pParentList

RIFF::List* DLS::Articulator::pParentList

protected

Definition at line 354 of file DLS.h.

The documentation for this class was generated from the following files:

- DLS.h
- DLS.cpp